import javax.microedition.lcdui.*;
import java.util.*;

public class fautocmt extends Thread implements CommandListener{
	
	Form fAutoCmt;
	ChoiceGroup cgAutoType;
	TextField tfID, tfURLImg, tfIDSticker, tfTextCmt, tfSleep;
	Command cmBack, cmPlay;
	StringItem siInfo;
	Thread auto;
	boolean tAutoCmt;
	public fautocmt(){
		fAutoCmt = new Form("Auto Comment panel");
		
		cgAutoType = new ChoiceGroup("auto Type:", Choice.EXCLUSIVE);
		tfID = new TextField("use ID:" , "", 1000, TextField.NUMERIC);
		tfURLImg = new TextField("use URL image:" , "", 1000, 0);
		tfIDSticker = new TextField("use ID sticker:" , "", 1000, TextField.NUMERIC);
		tfTextCmt = new TextField("Comment content:" , "", 5000, 0);
		tfSleep = new TextField("Sleep:" , "5000", 1000, TextField.NUMERIC);
		
		cmBack = new Command("Back", Command.EXIT, 1);
		cmPlay = new Command("Play", Command.OK, 2);
		
		cgAutoType.append("Auto newFeed", null);
		cgAutoType.append("Auto ID", null);
		//
		RMS2Form();
		//
		fAutoCmt.append(cgAutoType);
		fAutoCmt.append(tfID);
		fAutoCmt.append(tfURLImg);
		fAutoCmt.append(tfIDSticker);
		fAutoCmt.append(tfTextCmt);
		fAutoCmt.append(tfSleep);
		fAutoCmt.addCommand(cmBack);
		fAutoCmt.addCommand(cmPlay);
		fAutoCmt.setCommandListener(this);
	}
	
	public void commandAction(Command cm, Displayable dp){
		if(cm==cmBack){
			Display.getDisplay(midlet.m).setCurrent(midlet.m.lHome.lHome);
		}
		if(cm==cmPlay){
			if(auto==null){
				if(checkForm()){
					Form2RMS();
					startThread();
				}
			}else{
				fAutoCmt.removeCommand(cmPlay);
				stopThread();
			}
		}
	}
	
	public boolean stopThread(){
		if(auto!=null){
			// tắt vòng lặp
			if(tAutoCmt) {
				tAutoCmt= false;
				siInfo.setText("Stoping...");
			}
			//nếu thread đã dừng
			if(!auto.isAlive()){
				return true;
			}
			return false;
		}
		//thread chưa chạy
		return true;
	}
	
	public void startThread(){
		auto = new Thread(this);
		auto.start();
	}
	
	public void run(){
		fAutoCmt.deleteAll();
		fAutoCmt.removeCommand(cmPlay);
		siInfo = new StringItem("Info: ", "...");
		cmPlay = new Command("stop", Command.OK, 3);
		fAutoCmt.append(siInfo);
		fAutoCmt.addCommand(cmPlay);
		tAutoCmt = true;
		//
		long sleep = Long.parseLong(tfSleep.getString());
		while(tAutoCmt){
			//lấy danh sách các ID cần react
			String[] listIDCmt = getIdFromType();
			if(listIDCmt != null){
				siInfo.setText("get list ID done! (length="+listIDCmt.length+")...");
				for(int i=0; i<listIDCmt.length; i++){
					//da react id nay hay chua?
					if(!funcFB.checkReact("autoCmtLog.txt", midlet.m.UID+"_"+listIDCmt[i])){
						//tha cam xuc id nay
						if(funcFB.comment(midlet.m.Token, listIDCmt[i], tfTextCmt.getString(), tfIDSticker.getString(), tfURLImg.getString())){
							//thong bao va luu log
							siInfo.setText("id="+listIDCmt[i]+" comment DONE!...");
							//
						}else siInfo.setText("id="+listIDCmt[i]+" comment FAIL...");
						funcFB.writeReact("autoCmtLog.txt", midlet.m.UID+"_"+listIDCmt[i]);
					}else siInfo.setText("id="+listIDCmt[i]+" reacted!...");
					//
					funcJ2ME.sleep(sleep);
				}
			}else siInfo.setText("newFeeds  null?...");
			//
			funcJ2ME.sleep(sleep);
		}
		siInfo.setText("stoped");
		midlet.m.fAutoReact = null;
	}
	private String[] getIdFromType(){
		String[] res;
		if(cgAutoType.isSelected(0)){
			res = funcFB.getHome(midlet.m.Token);
		}else{
			String[] splitTf = funcJ2ME.split(tfID.getString(), "|");
			int count = ((splitTf.length<=1||splitTf[1].equals("")) ? 10 : Integer.parseInt(splitTf[1]));
			res = funcFB.getFeed(midlet.m.Token, splitTf[0], count);
		}
		return res;
	}
	private void RMS2Form(){
		String[] dataRMS = funcJ2ME.getRMS("thiendz_fautocmt");
		if(dataRMS!=null && dataRMS.length >=6){
			cgAutoType.setSelectedIndex(Integer.parseInt(dataRMS[0]), true);			
			//
			tfID.setString(dataRMS[1]);
			tfURLImg.setString(dataRMS[2]);
			tfIDSticker.setString(dataRMS[3]);
			tfTextCmt.setString(dataRMS[4]);
			tfSleep.setString(dataRMS[5]);
		}
	}
	
	private void Form2RMS(){
		String sCgAutoType = "";
		for(int i=0; i<cgAutoType.size(); i++)
			if(cgAutoType.isSelected(i)){
				sCgAutoType += i;
				break;
			}
		//
		String[] dataForm = {sCgAutoType, tfID.getString(), tfURLImg.getString(), tfIDSticker.getString(), tfTextCmt.getString(), tfSleep.getString()};
		funcJ2ME.saveRMS("thiendz_fautocmt", dataForm);
	}
	
	private boolean checkForm(){
		//chọn auto ID thì phải nhập ID
		if(cgAutoType.isSelected(1) && tfID.getString().equals("")){
			funcJ2ME.alert("ERROR", "Auto uid????", AlertType.ERROR);
			return false;
		}
		//bắt buộc phải chọn 1 trong 3
		if(tfIDSticker.getString().equals("") && tfURLImg.getString().equals("") && tfTextCmt.getString().equals("")){
			funcJ2ME.alert("ERROR", "IDSticker or URLimg or Text not empty?", AlertType.ERROR);
			return false;
		}
		//cảnh báo nếu nhập thời gian nghỉ dưới 5s
		if(Integer.parseInt(tfSleep.getString())<5000){
			funcJ2ME.alert("WARNING", "sleep <5000? block ?", AlertType.WARNING);
		}
		return true;
	}
}