import javax.microedition.lcdui.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.rms.*;
import java.util.*;


public class funcJ2ME{
	
	static Alert al;
	final static String hex =
		"%00%01%02%03%04%05%06%07%08%09%0a%0b%0c%0d%0e%0f%10%11%12%13%14%15%16%17%18%19%1a%1b%1c%1d%1e%1f" +
		"%20%21%22%23%24%25%26%27%28%29%2a%2b%2c%2d%2e%2f%30%31%32%33%34%35%36%37%38%39%3a%3b%3c%3d%3e%3f" +
		"%40%41%42%43%44%45%46%47%48%49%4a%4b%4c%4d%4e%4f%50%51%52%53%54%55%56%57%58%59%5a%5b%5c%5d%5e%5f" +
		"%60%61%62%63%64%65%66%67%68%69%6a%6b%6c%6d%6e%6f%70%71%72%73%74%75%76%77%78%79%7a%7b%7c%7d%7e%7f" +
		"%80%81%82%83%84%85%86%87%88%89%8a%8b%8c%8d%8e%8f%90%91%92%93%94%95%96%97%98%99%9a%9b%9c%9d%9e%9f" +
		"%a0%a1%a2%a3%a4%a5%a6%a7%a8%a9%aa%ab%ac%ad%ae%af%b0%b1%b2%b3%b4%b5%b6%b7%b8%b9%ba%bb%bc%bd%be%bf" +
		"%c0%c1%c2%c3%c4%c5%c6%c7%c8%c9%ca%cb%cc%cd%ce%cf%d0%d1%d2%d3%d4%d5%d6%d7%d8%d9%da%db%dc%dd%de%df" +
		"%e0%e1%e2%e3%e4%e5%e6%e7%e8%e9%ea%eb%ec%ed%ee%ef%f0%f1%f2%f3%f4%f5%f6%f7%f8%f9%fa%fb%fc%fd%fe%ff";
	    //get the encoded value of a single symbol, each return value is 3 characters long
	static String hex(int sym){
		return(hex.substring(sym*3, sym*3 + 3));
	}
	public static String urlEncode(String s) {
		StringBuffer sbuf = new StringBuffer();
		int len = s.length();
		for (int i = 0; i < len; i++) {
			int ch = s.charAt(i);
			if ('A' <= ch && ch <= 'Z') { // 'A'..'Z'
				sbuf.append((char)ch);
			} else if ('a' <= ch && ch <= 'z') { // 'a'..'z'
				sbuf.append((char)ch);
			} else if ('0' <= ch && ch <= '9') { // '0'..'9'
				sbuf.append((char)ch);
			} else if (ch == ' ') { // space
				sbuf.append('+');
			} else if (ch == '-' || ch == '_'   //these characters don't need encoding
					|| ch == '.' || ch == '*') {
				sbuf.append((char)ch);
			} else if (ch <= 0x007f) { // other ASCII
				sbuf.append(hex(ch));
			} else if (ch <= 0x07FF) { // non-ASCII <= 0x7FF
				sbuf.append(hex(0xc0 | (ch >> 6)));
				sbuf.append(hex(0x80 | (ch & 0x3F)));
			} else { // 0x7FF < ch <= 0xFFFF
				sbuf.append(hex(0xe0 | (ch >> 12)));
				sbuf.append(hex(0x80 | ((ch >> 6) & 0x3F)));
				sbuf.append(hex(0x80 | (ch & 0x3F)));
			}
		}
		return funcJ2ME.replace(sbuf.toString(), "+", "%20");
	}

	public static void alert(String title, String text, AlertType at){
		al = new Alert(title, text, null, at);
		Display.getDisplay(midlet.m).setCurrent(al);
	}
	
	public static String[] split(String splitStr, String delimiter) {
		StringBuffer token = new StringBuffer();
		Vector tokens = new Vector();
		// split
		char[] chars = splitStr.toCharArray();
		for (int i=0; i < chars.length; i++) {
			if (delimiter.indexOf(chars[i]) != -1) {
				// we bumbed into a delimiter
				if (token.length() > 0) {
					tokens.addElement(token.toString());
					token.setLength(0);
				}
			} else {
				token.append(chars[i]);
			}
		}
		// don't forget the "tail"...
		if (token.length() > 0) {
			tokens.addElement(token.toString());
		}
		// convert the vector into an array
		String[] splitArray = new String[tokens.size()];
		for (int i=0; i < splitArray.length; i++) {
			splitArray[i] = (String)tokens.elementAt(i);
		}
		return splitArray;
	}
	
	public static String httpPOST(String URL, String paramPost, String[] rqProperty) throws IOException{
		HttpConnection hc = null;
		InputStream is = null;
		OutputStream os = null;
		String res = null;
		try{
			hc = (HttpConnection)Connector.open(URL);
			hc.setRequestMethod("POST");
			if(rqProperty != null){
				for(int i=0; i<rqProperty.length;i+=2){
					hc.setRequestProperty(rqProperty[i], rqProperty[i+1]);
				}
			}
			if(paramPost != null){
				os = hc.openOutputStream();
				os.write(paramPost.getBytes());
				os.flush();
			}
			is = hc.openInputStream();
			if(hc.getResponseCode()==200){
				StringBuffer sb = new StringBuffer();
				int ch;
				while((ch = is.read())!=-1){
					sb.append((char)ch);
				}
				res = sb.toString();
			}else{
				throw new IOException("ERROR:statusCode="+hc.getResponseCode());
			}
		}catch(IOException e){
			throw new IOException(e.toString());
		}finally{
			if(hc != null) hc.close();
			if(is != null) is.close();
			if(os != null) os.close();
		}
		return res;
	}
	
	public static String httpGET(String URL, String[] rqProperty) throws IOException{
		HttpConnection hc = null;
		InputStream is = null;
		String res = null;
		try{
			hc = (HttpConnection) Connector.open(URL);
			hc.setRequestMethod("GET");
			if(rqProperty != null){
				for(int i=0; i<rqProperty.length;i+=2){
					hc.setRequestProperty(rqProperty[i], rqProperty[i+1]);
				}
			}
			is = hc.openInputStream();
			if(hc.getResponseCode()==200){
				StringBuffer sb = new StringBuffer();
				int ch;
				while((ch = is.read()) != -1){
					sb.append((char)ch);
				}
				res = sb.toString();
			}else{
				throw new IOException("Error:statusCode="+hc.getResponseCode());
			}
		}catch(IOException e){
			throw new IOException(e.toString());
		}finally{
			if(hc != null) hc.close();
			if(is != null) is.close();
		}
		return res;
	}
	
	public static void sleep(long sleep){
		try{
			Thread.sleep(sleep);
		}catch(Exception e){
		}
	}
	
	public static void println(String print){
		System.out.println(print);
	}
	
	public static String[] getRMS(String nameRMS){
		String[] res = null;
		int num;
		byte[] data;
		RecordStore rs;
		try{
			rs = RecordStore.openRecordStore(nameRMS, true);
			num = rs.getNumRecords();
			if(num>0){
				res = new String[num];
				for(int i=0; i<num; i++){
					data = rs.getRecord(i+1);
					res[i] = new String(data, 0, data.length);
					res[i] = res[i].equals(" ")?"":res[i];
				}
			}
			rs.closeRecordStore();
		}catch(Exception e){
			funcJ2ME.println(e.toString());
		}
		return res;
	}
	
	public static void saveRMS(String nameRMS, String[] arrData){
		RecordStore rs;
		byte[] data;
		try{
			rs = RecordStore.openRecordStore(nameRMS, true);
			if(rs.getNumRecords()==0){
				for(int i=0; i<arrData.length; i++){
					data = (arrData[i].equals("")?" ":arrData[i]).getBytes();
					rs.addRecord(data, 0, data.length);
				}
			}else{
				for(int i=0; i<arrData.length; i++){
					data = (arrData[i].equals("")?" ":arrData[i]).getBytes();
					rs.setRecord(i+1, data, 0, data.length);
				}
			}
			rs.closeRecordStore();
		}catch(Exception e){
			funcJ2ME.println(e.toString());
		}
	}
	
	public static String replace(String str,String pattern,String replace){
		int s =0;
		int e =0;
		StringBuffer result =new StringBuffer();
		while((e = str.indexOf( pattern, s ))>=0){
			result.append(str.substring( s, e )); 
			result.append( replace ); 
			s = e+pattern.length();
		} 
		result.append( str.substring( s ));
		return result.toString();
	}
}