import javax.microedition.lcdui.*;
import java.util.*;

public class fautoreact extends Thread implements CommandListener{
	Form fAutoReact;
	ChoiceGroup cgAutoType, cgReactType;
	TextField tfID, tfSleep;
	StringItem siInfo;
	Command cmPlay, cmBack, cmStop;
	
	private Thread auto;
	private boolean tAutoReact;
	
	public fautoreact(){
		
		fAutoReact = new Form("Auto Reaction panel");
		cgAutoType = new ChoiceGroup("Auto Type:", Choice.EXCLUSIVE);
		cgReactType = new ChoiceGroup("React Type:", Choice.MULTIPLE);
		tfID = new TextField("ID auto(ID|count):", "", 1000, 0);
		tfSleep = new TextField("Sleep:", "5000", 7, TextField.NUMERIC);
		cmPlay = new Command("Play", Command.OK, 1);
		cmBack = new Command("Back", Command.EXIT, 2);
		
		cgAutoType.append("Auto NewFeeds", null);
		cgAutoType.append("Auto IDs", null);
		cgAutoType.setSelectedIndex(0, true);
		
		cgReactType.append("LIKE", null);
		cgReactType.append("LOVE", null);
		cgReactType.append("WOW", null);
		cgReactType.append("HAHA", null);
		cgReactType.append("ANGRY", null);
		cgReactType.append("SAD", null);
		cgReactType.setSelectedIndex(0, true);
		cgReactType.setSelectedIndex(1, true);
		cgReactType.setSelectedIndex(2, true);
		//
		RMS2Form();
		//
		fAutoReact.append(cgAutoType);
		fAutoReact.append(tfID);
		fAutoReact.append(cgReactType);
		fAutoReact.append(tfSleep);
		fAutoReact.addCommand(cmPlay);
		fAutoReact.addCommand(cmBack);
		fAutoReact.setCommandListener(this);
		
	}
	public void commandAction(Command cm, Displayable dp){
		if(cm==cmBack){
			Display.getDisplay(midlet.m).setCurrent(midlet.m.lHome.lHome);
		}
		if(cm==cmPlay){
			if(auto==null){
				Form2RMS();
				if(checkForm()){
					startThread();
				}
			}else{
				//dừng thread và trả về trạng thái đã dừng được chưa :D
				fAutoReact.removeCommand(cmPlay);
				stopThread();
			}
		}
	}
	
	public boolean stopThread(){
		if(auto!=null){
			// tắt vòng lặp
			if(tAutoReact) {
				tAutoReact= false;
				siInfo.setText("Stoping...");
			}
			//nếu thread đã dừng
			if(!auto.isAlive()){
				return true;
			}
			return false;
		}
		//thread chưa chạy
		return true;
	}
	
	public void startThread(){
		auto = new Thread(this);
		auto.start();
	}
	
	private boolean checkForm(){
		//kiểm tra xem, phải chọn ít nhất 1 lựa chọn
		int count = 0;
		for(int i=0; i<cgAutoType.size();i++){
			if(cgAutoType.isSelected(i)) count++;
		}
		if(count==0){
			funcJ2ME.alert("ERROR", "empty React type?", AlertType.ERROR);
			return false;
		}
		//chọn auto ID thì phải nhập ID
		if(cgAutoType.isSelected(1) && tfID.getString().equals("")){
			funcJ2ME.alert("ERROR", "Auto uid????", AlertType.ERROR);
			return false;
		}
		//cảnh báo nếu nhập thời gian nghỉ dưới 5s
		if(Integer.parseInt(tfSleep.getString())<5000){
			funcJ2ME.alert("WARNING", "sleep <5000? block ?", AlertType.WARNING);
		}
		return true;
	}
	
	
	
	public void run(){
		//--------default
		fAutoReact.deleteAll();
		fAutoReact.removeCommand(cmPlay);
		siInfo = new StringItem("Info: ", "...");
		cmPlay = new Command("stop", Command.OK, 3);
		fAutoReact.append(siInfo);
		fAutoReact.addCommand(cmPlay);
		tAutoReact = true;
		//-->lấy thời gian nghỉ
		long sleep = Long.parseLong(tfSleep.getString());
		while(tAutoReact){
			//lấy danh sách các ID cần react
			String[] listIDReact = getIdFromType();
			if(listIDReact != null){
				siInfo.setText("get list ID done! (length="+listIDReact.length+")...");
				for(int i=0; i<listIDReact.length; i++){
					//da react id nay hay chua?
					if(!funcFB.checkReact("autoReactLog.txt", midlet.m.UID+"_"+listIDReact[i])){
						//tha cam xuc id nay
						if(funcFB.react(midlet.m.Token, listIDReact[i], getTypeCx())){
							//thong bao va luu log
							siInfo.setText("id="+listIDReact[i]+" react DONE!...");
							//
						}else siInfo.setText("id="+listIDReact[i]+" react FAIL...");
						funcFB.writeReact("autoReactLog.txt", midlet.m.UID+"_"+listIDReact[i]);
					}else siInfo.setText("id="+listIDReact[i]+" reacted!...");
					//
					funcJ2ME.sleep(sleep);
				}
			}else siInfo.setText("newFeeds  null?...");
			//
			funcJ2ME.sleep(sleep);
		}
		siInfo.setText("stoped");
		midlet.m.fAutoReact = null;
	}
	
	private String getTypeCx(){
		boolean[] getCx = new boolean[cgReactType.size()];
		cgReactType.getSelectedFlags(getCx);
		Random r= new Random();
		int rand;
		do{
			rand = r.nextInt(getCx.length);
		}while(!getCx[rand]);
		return cgReactType.getString(rand);
	}

	private void RMS2Form(){
		String[] dataRMS = funcJ2ME.getRMS("thiendz_fautoreact");
		if(dataRMS!=null && dataRMS.length >=4){
			cgAutoType.setSelectedIndex(Integer.parseInt(dataRMS[0])>1?0:1, true);
			tfID.setString(dataRMS[1]);
			//
			for(int i=0; i<cgReactType.size(); i++) 
				cgReactType.setSelectedIndex(i, false);
			char[] cCgReactType = dataRMS[2].toCharArray();
			for(int i=0; i<cCgReactType.length; i++){
				int selected = ((int)cCgReactType[i]) - 48;
				cgReactType.setSelectedIndex(selected>=cgReactType.size()?0:selected, true);
			}
			//
			tfSleep.setString(dataRMS[3]);
		}
	}
	
	private void Form2RMS(){
		//
		String sCgAutoType = "";
		for(int i=0; i<cgAutoType.size(); i++)
			if(cgAutoType.isSelected(i)){
				sCgAutoType += i;
				break;
			}
		//
		String sCgReactType = "";
		for(int i=0; i<cgReactType.size(); i++)
			if(cgReactType.isSelected(i))
				sCgReactType += i;
		//
		String[] dataForm = {sCgAutoType, tfID.getString(), sCgReactType, tfSleep.getString()};
		funcJ2ME.saveRMS("thiendz_fautoreact", dataForm);
	}
	
	private String[] getIdFromType(){
		String[] res;
		if(cgAutoType.isSelected(0)){
			res = funcFB.getHome(midlet.m.Token);
		}else{
			String[] splitTf = funcJ2ME.split(tfID.getString(), "|");
			int count = ((splitTf.length<=1||splitTf[1].equals("")) ? 10 : Integer.parseInt(splitTf[1]));
			res = funcFB.getFeed(midlet.m.Token, splitTf[0], count);
		}
		return res;
	}
}

